package jalview.schemes;

import java.util.*;
import java.awt.*;

public class ResidueColourScheme implements ColourSchemeI{
    Color    [] colors;
    int       threshold = 0;
    public Vector   consensus;

    public ResidueColourScheme(Color[] colors, int threshold) {
        this.colors    = colors;
	this.threshold = threshold;
    }

    public ResidueColourScheme()
    {   }

    public void setConsensus(Vector consensus)
    {
      this.consensus = consensus;
    }

    public Color findColour(String aa)
    {
      return colors[((Integer)(ResidueProperties.aaHash.get(aa))).intValue()];
    }

    public Color findColour(String s, int j) {

       if( threshold==0 || aboveThreshold(s,j))
          return colors[((Integer)(ResidueProperties.aaHash.get(s))).intValue()];
       else
          return Color.white;

    }

    public int getThreshold() {
	return threshold;
    }

    public void setThreshold(int ct) {
	threshold = ct;
    }

    public boolean aboveThreshold(String s, int j)
    {
	Hashtable hash = (Hashtable)consensus.elementAt(j);

        if ( ( (Integer) hash.get("maxCount")).intValue() != -1 && hash.contains(s))
        {
               ////  resCount////////////////////                  ///////////////seq count////////////
          double sc = ( (Integer) hash.get(s)).intValue()  * 100.0 / ( (Integer) hash.get("size")).intValue();

          if (sc >= threshold)
            return true;

        }

	return false;
    }
}
